var infNamespace = 'com.change_vision.jude.api.inf'
var Key = Java.type(infNamespace + '.presentation.PresentationPropertyConstants.Key')
var ILinkPresentation = Java.type(infNamespace + '.presentation.ILinkPresentation')
var Point2D = Java.type('java.awt.geom.Point2D.Double')

//////////////////////////
var MARGIN_X = 5
var MARGIN_Y = 5
//////////////////////////

getSelectedPresentations().forEach(
    function (presentation) {
        if (presentation instanceof ILinkPresentation) {
            return adjustPositionLabel(presentation, MARGIN_X, MARGIN_Y)
        }
    }
)

function adjustPositionLabel(linkPresentation, marginX, marginY) {
    var startPoint = linkPresentation.getPoints()[0]
    var nextPoint = linkPresentation.getPoints()[1]
    var sourcePresentation = linkPresentation.getSourceEnd()
    var sourcePRectangle = sourcePresentation.getRectangle()
    var referencePoint = null
    if (nextPoint.x > sourcePRectangle.getMaxX() && nextPoint.y > sourcePRectangle.getMaxY()) { // 右下に出力されている場合
        referencePoint = new Point2D(sourcePRectangle.getMaxX(), sourcePRectangle.getMaxY())
    } else if (nextPoint.x > sourcePRectangle.getMaxX() && nextPoint.y < sourcePRectangle.getMinY()) { // 右上に出力されている場合
        // 未実装
    } else if (nextPoint.x > sourcePRectangle.getMaxX()) { // 右辺と交わる場合
        var belowPoint = new Point2D(nextPoint.x, startPoint.y)
        var middleBelowPoint = new Point2D(sourcePRectangle.getMaxX(), startPoint.y)
        referencePoint = new Point2D(middleBelowPoint.x, 
            middleBelowPoint.y + (startPoint.distance(middleBelowPoint) 
            * (belowPoint.distance(nextPoint) * ((sourcePRectangle.getCenterY() > nextPoint.y) ? -1 : 1)) 
            / startPoint.distance(belowPoint)))
    } else if (nextPoint.y > sourcePRectangle.getMaxY()) { //下辺と交わる場合
        var belowPoint = new Point2D(startPoint.x, nextPoint.y)
        var middleBelowPoint = new Point2D(startPoint.x, sourcePRectangle.getMaxY())
        referencePoint = new Point2D(middleBelowPoint.x + (startPoint.distance(middleBelowPoint) 
            * (belowPoint.distance(nextPoint) * ((sourcePRectangle.getCenterX() > nextPoint.x) ? -1 : 1)) 
            / startPoint.distance(belowPoint)), middleBelowPoint.y)
    } else {
        // 未実装
    }
    if (referencePoint == null) {
        print("info: " + linkPresentation.getLabel() + "のラベルの位置計算は未実装のため移動できません。")
        return
    }
    var newX = referencePoint.x + marginX
    var newY = referencePoint.y + marginY
    try {
        astah.getTransactionManager().beginTransaction()
        linkPresentation.setProperty(Key.NAME_X, newX)
        linkPresentation.setProperty(Key.NAME_Y, newY)
        astah.getTransactionManager().endTransaction()
        print("info: " + linkPresentation.getLabel() + "のラベル位置を変更しました。")
    } catch (e) {
        astah.getTransactionManager().abortTransaction()
        print("error: " + linkPresentation.getLabel() + "のラベル位置変更中にエラーが発生しました。")
        throw e
    }
}

function getSelectedPresentations() {
    var viewManager = astah.getViewManager()
    var diagramViewManager = viewManager.getDiagramViewManager()
    var selectedPresentations = diagramViewManager.getSelectedPresentations()
    return Java.from(selectedPresentations)
}